# http://had.co.nz/reshape

library(reshape2)

head(airquality)
#   Ozone Solar.R Wind Temp Month Day
# 1    41     190  7.4   67     5   1
# 2    36     118  8.0   72     5   2
# 3    12     149 12.6   74     5   3
# 4    18     313 11.5   62     5   4
# 5    NA      NA 14.3   56     5   5
# 6    28      NA 14.9   66     5   6

#wide to long
aqm <- melt(airquality, id=c("Month", "Day"), 
            na.rm=TRUE)

#long to wide
aqm_cast <- dcast(aqm, Month + Day ~ variable)

  # Month Day variable value
# 1     5   1    Ozone    41
# 2     5   2    Ozone    36
# 3     5   3    Ozone    12
# 4     5   4    Ozone    18
# 6     5   6    Ozone    28
# 7     5   7    Ozone    23

# http://had.co.nz/plyr

library(plyr)

avg_aq <- ddply(airquality,
                .(month),
                summarise,
                temp = mean(temp),
                wind = mean(wind))



#Combine different data frames into one piece
m1 <- merge(authors, books, 
             by.x = "surname", 
             by.y = "name")
